## pitest 1.9.0

=== debian/changelog ===
pitest (1.9.0-1+deb12+1) bookworm; urgency=medium

  [ Nicolai Buchwitz ]
  * feat: Remove redundant error messages in fw update

  [ Lino Sanfilippo ]
  * fix: remove unused function piControlFindVariable
  * chore: switch to piControl v2.4.0
  * feat: Support firmware rescue mode
  * fix: correct parameter of function writeData

  [ Thomas Böhler ]
  * chore: release v1.9.0

 -- Thomas Böhler <t.boehler@kunbus.com>  Mon, 08 Dec 2025 07:01:53 +0100

pitest (1.8.1-1+deb12+1) bookworm; urgency=medium

  [ Ramiro Gsponer ]
  * chore: switch to piControl v2.3.5
  * fix: Add support for virtual devices
  * feat: Use defines for module type identifiers

  [ Lino Sanfilippo ]
  * refactor: use temporary variable in loop
  * fix: do not apply mask to active devices

  [ Ramiro Gsponer ]
  * chore: switch to piControl v2.3.6
  * chore: Release v1.8.1

 -- Ramiro Gsponer <r.gsponer@kunbus.com>  Mon, 02 Jun 2025 12:11:12 +0200

pitest (1.8.0-1+deb12+1) bookworm; urgency=medium

  [ Thomas Böhler ]
  * chore(deb): switch upstream to 1.x

  [ Lino Sanfilippo ]
  * chore: switch to latest piControl version
  * build: correct cmake directories path
  * feat: support command line parameter for forced update
  * doc: Add description for the force parameter
  * feat: provide command line option for version info
  * doc: Add description for the Version parameter
  * refactor: use tabs instead of spaces in piControlIf.c
  * refactor: in piControlIf.h use correct SPDX Header
  * refactor: get rid of obsolete code compiled with KUNBUS_TEST defined

  [ Thomas Böhler ]
  * fix: return proper error on piControlOpen
  * doc: rewrite man page with scdoc
  * doc: bundle examples under separate heading
  * doc: add proper synopsis for piTest man page
  * doc: add reference to picontrol_ioctl man page
  * fix: avoid empty initializer braces in long_opts
  * ci: build edge packages
  * ci: add commit linting job
  * doc: Update -f option for better readability
  * doc: add optional force parameter to synopsis
  * doc: reference man page in README.md
  * doc: fix indentation of -V option in help output
  * fix: don't fail on up to date firmware
  * feat: show notice on successful firmware update
  * fix: be consistent with firmware update messages
  * doc: --module value must be greater than 0
  * build: install moved picontrol_ioctl man page

  [ Lino Sanfilippo ]
  * fix: remove superfluous call of piShowLastMessage
  * feat: add messages for firmware update

  [ Thomas Böhler ]
  * fix(fwupdate): require confirmation before update
  * feat(fwupdate): add spinner
  * feat(fwupdate): add -q for fwupdate
  * build: link against libpthread
  * fix(deb): add scdoc dependency

 -- Ramiro Gsponer <r.gsponer@kunbus.com>  Thu, 27 Mar 2025 11:44:00 +0100

pitest (1.7.0-1+deb12+1) bookworm; urgency=medium

  [ Ahmad Arabi Katbi ]
  * feat: Add module name for Connect5

 -- Sven Sager <s.sager@kunbus.com>  Mon, 11 Nov 2024 08:56:13 +0100

pitest (1.6.0-1+revpi12+1) bookworm; urgency=medium

  [ Thomas Böhler ]
  * feat: Add flag to give address of specific module
  * Fix failing compilation for gcc < 12.2.0
  * Fix spelling mistake in help output for `--module`

  [ Philipp Rosenberger ]
  * Switch back to the debian/ namespace

  [ Thomas Böhler ]
  * Ensure list  of `struct option` ends with zeros

  [ Nicolai Buchwitz ]
  * fix: Run local pipelines on debian/* branches
  * chore: Add MIT to ci files
  * ci: Run local pipeline only if file exists
  * doc: Update usage in README

  [ Thomas Böhler ]
  * doc: Update source code location
  * ci: Lint REUSE in ci

 -- Thomas Böhler <t.boehler@kunbus.com>  Mon, 04 Mar 2024 10:28:40 +0100

pitest (1.5.0-1+revpi12+1) bookworm; urgency=medium

  [ Thomas Böhler ]
  * chore: Make repository REUSE compliant

  [ Nicolai Buchwitz ]
  * ci: Add pipeline for package build

  [ Thomas Böhler ]
  * chore: Add move to GitLab to README

  [ Nicolai Buchwitz ]
  * feat: Add support for RevPi RO

  [ Thomas Böhler ]
  * doc: Add build instructions to README.md
  * refactor: Use piControl GitLab link in submodule

  [ Lino Sanfilippo ]
  * Add new command line parameter to retrieve RO counters

  [ Nicolai Buchwitz ]
  * doc(RO): Explain RO counter usage
  * chore: Update piControl submodule to latest hash

 -- Thomas Böhler <t.boehler@kunbus.com>  Mon, 13 Nov 2023 15:28:51 +0100

pitest (1.4.1-1+revpi12+1) bookworm; urgency=medium

  * Update package for bookworm

 -- Thomas Böhler <t.boehler@kunbus.com>  Fri, 13 Oct 2023 13:51:17 +0200

pitest (1.4.1-1+revpi11+1) bullseye; urgency=medium

  * docs: Correct source code url
  * docs: Correct RevolutionPi website
  * chore: Update piControl submodule to latest hash

 -- Thomas Böhler <t.boehler@kunbus.com>  Mon, 19 Jun 2023 09:15:01 +0200

pitest (1.4.0-1+revpi11+1) bullseye; urgency=medium

  * Add MIT license in LICENSE.txt
  * Add piControl dependency, correct Makefile
  * Change build system to CMake
  * Add README.md with help output of binary
  * fix: Add missing man page
  * fix: Force link of custom_target piControlReset
  * fix: End italics by reverting formatting
  * build: Don't depend on a C++ compiler for CMake
  * Initial debianization
  * Assign correct license to sources

  [ Nicolai Buchwitz ]
  * Fix gcc -Wformat= complaints
  * Replace strncpy by snprintf
  * Add SPDX headers
  * Cleanup debianization
  * piTest: Add Connect 4 as known device

 -- Thomas Böhler <t.boehler@kunbus.com>  Wed, 24 May 2023 08:23:13 +0200

picontrol (1.3.1-1) stable; urgency=medium

  * Make CROSS_COMPILE optionally configureable from environment
  * Allow spaces (two commands) in CROSS_COMPILE environment variable
  * piControl: Dont use wrong offset for default values
  * debia/control: Correct Maintainer entry.

 -- Lino Sanfilippo <l.sanfilippo@kunbus.com>  Tue, 16 Mar 2021 13:17:05 +0100

picontrol (1.3.0-1) stable; urgency=medium

  * Add RevPi MIO support

 -- Philipp Rosenberger <p.rosenberger@kunbus.com>  Wed, 10 Mar 2021 14:06:05 +0100



## pitest 2.1.0

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023-2025 KUNBUS GmbH
#
# SPDX-License-Identifier: MIT

set(TARGET piTest)
set(SOURCES
	piTest.c
	piControlIf.c
)

add_executable(${TARGET} ${SOURCES})
target_include_directories(${TARGET} PRIVATE ../include ../lib/piControl/src)

# link pthread
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
target_link_libraries(${TARGET} PRIVATE Threads::Threads)

install(TARGETS ${TARGET} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# install the symbolic link by first creating it in the binary directory and
# then moving it to the install directory.
# this needs to be done this way because the alternative way of doing
# `install(CODE...` doesn't respect the installation prefix.
add_custom_target(piControlReset ALL
	BYPRODUCTS piControlReset
	COMMAND ln -fs ${TARGET} ${CMAKE_CURRENT_BINARY_DIR}/piControlReset)
add_dependencies(piControlReset ${TARGET})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/piControlReset
	DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
pitest (2.1.0-1+deb13+1) trixie; urgency=medium

  * Initial release for trixie

 -- Thomas Böhler <t.boehler@kunbus.com>  Mon, 08 Dec 2025 12:55:20 +0100

## pitest 2.1.1

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 KUNBUS GmbH
#
# SPDX-License-Identifier: MIT

cmake_minimum_required(VERSION 3.7)

project(piTest LANGUAGES C)

include(GNUInstallDirs)

add_subdirectory(src)
add_subdirectory(doc)

=== doc/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023-2025 KUNBUS GmbH
#
# SPDX-License-Identifier: MIT

find_program(SCDOC scdoc REQUIRED)

add_custom_target(
	piTest.1 ALL
	COMMAND ${SCDOC} < ${CMAKE_CURRENT_SOURCE_DIR}/piTest.1.scd > ${CMAKE_CURRENT_BINARY_DIR}/piTest.1
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/piTest.1.scd
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/piTest.1
	DESTINATION ${CMAKE_INSTALL_MANDIR}/man1/
)

install(FILES ../lib/piControl/src/picontrol_ioctl.4 DESTINATION ${CMAKE_INSTALL_MANDIR}/man4)

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023-2025 KUNBUS GmbH
#
# SPDX-License-Identifier: MIT

set(TARGET piTest)
set(SOURCES
	piTest.c
	piControlIf.c
)

add_executable(${TARGET} ${SOURCES})
target_include_directories(${TARGET} PRIVATE ../include ../lib/piControl/src)

# link pthread
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
target_link_libraries(${TARGET} PRIVATE Threads::Threads)

install(TARGETS ${TARGET} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

set(LINK_NAME ${CMAKE_CURRENT_BINARY_DIR}/piControlReset)

add_custom_command(
    OUTPUT ${LINK_NAME}
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${TARGET} piControlReset
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${TARGET}
)

add_custom_target(generate_piControlReset ALL DEPENDS ${LINK_NAME})

install(FILES ${LINK_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})

=== lib/piControl/Makefile ===
# SPDX-License-Identifier: GPL-2.0-only
# SPDX-FileCopyrightText: 2016-2024 KUNBUS GmbH

obj-m := piControl.o

#add other objects e.g. test.o
piControl-y  = src/piControlMain.o
piControl-y += src/piIOComm.o
piControl-y += src/piDIOComm.o
piControl-y += src/piAIOComm.o
piControl-y += src/RevPiDevice.o
piControl-y += src/json.o
piControl-y += src/piConfig.o
piControl-y += src/RS485FwuCommand.o
piControl-y += src/piFirmwareUpdate.o
piControl-y += src/PiBridgeMaster.o
piControl-y += src/kbUtilities.o
piControl-y += src/systick.o
piControl-y += src/revpi_common.o
piControl-y += src/revpi_compact.o
piControl-y += src/revpi_core.o
piControl-y += src/revpi_gate.o
piControl-y += src/revpi_flat.o
piControl-y += src/pt100.o
piControl-y += src/revpi_mio.o
piControl-y += src/revpi_ro.o

ccflags-y := -O2
ccflags-y += -I$(src)/src
ccflags-y += -D__KUNBUSPI_KERNEL__ -I$(src)
ccflags-$(_ACPI_DEBUG) += -DACPI_DEBUG_OUTPUT

KBUILD_CFLAGS += -g

PWD := $(shell pwd)

all:
	$(MAKE) -C $(KDIR) M=$(PWD) modules

clean:
	$(MAKE) -C $(KDIR) M=$(PWD) clean
	rm -f $(piControl-y)

=== debian/changelog ===
pitest (2.1.1-1+deb13+1) trixie; urgency=medium

  [ Erik Sallmann ]
  * build: fix symlink creation with ninja

  [ Thomas Böhler ]
  * fix: use proper return code for piControlReset
  * chore: release v2.1.1

 -- Thomas Böhler <t.boehler@kunbus.com>  Thu, 05 Feb 2026 10:09:52 +0100

=== debian/control ===
Source: pitest
Section: electronics
Priority: optional
Maintainer: KUNBUS GmbH <support@kunbus.com>
Rules-Requires-Root: no
Homepage: https://revolutionpi.com/
Vcs-Browser: https://gitlab.com/revolutionpi/revpi-pitest
Vcs-Git: https://gitlab.com/revolutionpi/revpi-pitest.git -b debian/trixie
Build-Depends:
  cmake,
  debhelper-compat (= 13),
  scdoc,
Standards-Version: 4.7.2

Package: pitest
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Revolution Pi command line utility
 Interact with the in-kernel piControl process to list I/O devices and
 gateway devices attached to a RevPi device, read and write values in the
 process image and reset the piControl process.  Comes with full source
 code.  Revolution Pi is a set of IoT products based on the Raspberry Pi
 and geared towards industrial usage.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@
